import { TreeGrid } from '..';
import { QueryCellInfoEventArgs, RowDataBoundEventArgs } from '@syncfusion/ej2-grids';
/**
 * TreeGrid render module
 *
 * @hidden
 */
export declare class Render {
    private parent;
    private templateResult;
    /**
     * Constructor for render module
     *
     * @param {TreeGrid} parent - Tree Grid instance
     */
    constructor(parent?: TreeGrid);
    /**
     * Updated row elements for TreeGrid
     *
     * @param {RowDataBoundEventArgs} args - Row details before its bound to DOM
     * @returns {void}
     */
    RowModifier(args: RowDataBoundEventArgs): void;
    /**
     * cell renderer for tree column index cell
     *
     * @param {QueryCellInfoEventArgs} args - Cell detail before its bound to DOM
     * @returns {void}
     */
    cellRender(args: QueryCellInfoEventArgs): void;
    private updateTreeCell;
    /**
     * @param {string} columnUid - Defines column uid
     * @returns {void}
     * @hidden
     */
    private refreshReactColumnTemplateByUid;
    private columnTemplateResult;
    private reactTemplateRender;
    destroy(): void;
}
